var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewChild, Input, ElementRef, Renderer2 } from '@angular/core';
var QrCode = require('qrcode');
var QrCodeCreateComponent = /** @class */ (function () {
    function QrCodeCreateComponent(renderer) {
        this.renderer = renderer;
        this.qrCodeType = 'url';
        this.qrCodeVersion = '';
        this.width = 11;
        this.margin = 4;
        this.qrScale = 4;
        this.qrCodeECLevel = 'M';
        this.qrCodeValue = 'SK2504 is the best in the world';
        this.qrCodeColorLight = '#ffffff';
        this.qrCodeColorDark = '#000000';
    }
    QrCodeCreateComponent.prototype.ngOnInit = function () {
    };
    QrCodeCreateComponent.prototype.ngOnChanges = function () {
        this.produceQrCode();
    };
    QrCodeCreateComponent.prototype.produceQrCode = function () {
        if (this.qrCodeValue) {
            switch (this.qrCodeType) {
                case 'canvas':
                    this.createQrCanvas();
                    break;
                case 'img':
                case 'url':
                default:
                    this.createQrUrlImage();
                    break;
            }
        }
        else {
            return;
        }
    };
    QrCodeCreateComponent.prototype.createQrCanvas = function () {
        var _this = this;
        var canvasEl = this.renderer.createElement('canvas');
        this.toCanvasQr(canvasEl).then(function (data) {
            _this.renderElement(canvasEl);
        }).catch(function (error) {
            console.error(error);
        });
    };
    QrCodeCreateComponent.prototype.createQrUrlImage = function () {
        var _this = this;
        var imgEl = this.renderer.createElement('img');
        this.toImgUrlQr().then(function (url) {
            imgEl.setAttribute('src', url);
            _this.renderElement(imgEl);
        }).catch(function (err) {
            console.error(err);
        });
    };
    QrCodeCreateComponent.prototype.toCanvasQr = function (canvasEl) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            QrCode.toCanvas(canvasEl, _this.qrCodeValue, {
                version: _this.qrCodeVersion,
                errorCorrectionLevel: _this.qrCodeECLevel,
                width: _this.width,
                margin: _this.margin,
                scale: _this.qrScale,
                color: {
                    light: _this.qrCodeColorLight,
                    dark: _this.qrCodeColorDark
                }
            }, function (error) {
                error ? reject(error) : resolve('success');
            });
        });
    };
    QrCodeCreateComponent.prototype.toImgUrlQr = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            QrCode.toDataURL(_this.qrCodeValue, {
                version: _this.qrCodeVersion,
                errorCorrectionLevel: _this.qrCodeECLevel,
                width: _this.width,
                margin: _this.margin,
                scale: _this.qrScale,
                color: {
                    light: _this.qrCodeColorLight,
                    dark: _this.qrCodeColorDark
                }
            }, function (error, url) {
                error ? reject(error) : resolve(url);
            });
        });
    };
    QrCodeCreateComponent.prototype.renderElement = function (element) {
        if (this.qrCodeDiv) {
            for (var _i = 0, _a = this.qrCodeDiv.nativeElement.childNodes; _i < _a.length; _i++) {
                var child = _a[_i];
                this.renderer.removeChild(this.qrCodeDiv.nativeElement, child);
            }
            this.renderer.appendChild(this.qrCodeDiv.nativeElement, element);
        }
    };
    __decorate([
        Input('qrCodeType'),
        __metadata("design:type", String)
    ], QrCodeCreateComponent.prototype, "qrCodeType", void 0);
    __decorate([
        Input('qrCodeVersion'),
        __metadata("design:type", String)
    ], QrCodeCreateComponent.prototype, "qrCodeVersion", void 0);
    __decorate([
        Input('qrCodeStyle'),
        __metadata("design:type", String)
    ], QrCodeCreateComponent.prototype, "qrCodeClass", void 0);
    __decorate([
        Input('width'),
        __metadata("design:type", Number)
    ], QrCodeCreateComponent.prototype, "width", void 0);
    __decorate([
        Input('margin'),
        __metadata("design:type", Number)
    ], QrCodeCreateComponent.prototype, "margin", void 0);
    __decorate([
        Input('scale'),
        __metadata("design:type", Number)
    ], QrCodeCreateComponent.prototype, "qrScale", void 0);
    __decorate([
        Input('qrCodeECLevel'),
        __metadata("design:type", String)
    ], QrCodeCreateComponent.prototype, "qrCodeECLevel", void 0);
    __decorate([
        Input('qrCodeValue'),
        __metadata("design:type", String)
    ], QrCodeCreateComponent.prototype, "qrCodeValue", void 0);
    __decorate([
        Input('qrCodeColorLight'),
        __metadata("design:type", String)
    ], QrCodeCreateComponent.prototype, "qrCodeColorLight", void 0);
    __decorate([
        Input('qrCodeColorDark'),
        __metadata("design:type", String)
    ], QrCodeCreateComponent.prototype, "qrCodeColorDark", void 0);
    __decorate([
        ViewChild('qrCodeDiv'),
        __metadata("design:type", ElementRef)
    ], QrCodeCreateComponent.prototype, "qrCodeDiv", void 0);
    QrCodeCreateComponent = __decorate([
        Component({
            selector: 'app-qrcode-create',
            template: '<div [class]="qrCodeClass" #qrCodeDiv></div>'
        }),
        __metadata("design:paramtypes", [Renderer2])
    ], QrCodeCreateComponent);
    return QrCodeCreateComponent;
}());
export { QrCodeCreateComponent };
//# sourceMappingURL=qrCodeCreate.component.js.map