/*
  Ported to JavaScript by Lazar Laszlo 2011
  
  lazarsoft@gmail.com, www.lazarsoft.info
  
*/
/*
*
* Copyright 2007 ZXing authors
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
var DataMask000 = /** @class */ (function () {
    function DataMask000() {
        this.isMasked = function (i, j) {
            return ((i + j) & 0x01) == 0;
        };
    }
    DataMask000.prototype.unmaskBitMatrix = function (bits, dimension) {
        for (var i = 0; i < dimension; i++) {
            for (var j = 0; j < dimension; j++) {
                if (this.isMasked(i, j)) {
                    bits.flip(j, i);
                }
            }
        }
    };
    return DataMask000;
}());
export { DataMask000 };
var DataMask001 = /** @class */ (function () {
    function DataMask001() {
        this.isMasked = function (i, j) {
            return (i & 0x01) == 0;
        };
    }
    DataMask001.prototype.unmaskBitMatrix = function (bits, dimension) {
        for (var i = 0; i < dimension; i++) {
            for (var j = 0; j < dimension; j++) {
                if (this.isMasked(i, j)) {
                    bits.flip(j, i);
                }
            }
        }
    };
    return DataMask001;
}());
export { DataMask001 };
var DataMask010 = /** @class */ (function () {
    function DataMask010() {
        this.isMasked = function (i, j) {
            return j % 3 == 0;
        };
    }
    DataMask010.prototype.unmaskBitMatrix = function (bits, dimension) {
        for (var i = 0; i < dimension; i++) {
            for (var j = 0; j < dimension; j++) {
                if (this.isMasked(i, j)) {
                    bits.flip(j, i);
                }
            }
        }
    };
    return DataMask010;
}());
export { DataMask010 };
var DataMask011 = /** @class */ (function () {
    function DataMask011() {
        this.isMasked = function (i, j) {
            return (i + j) % 3 == 0;
        };
    }
    DataMask011.prototype.unmaskBitMatrix = function (bits, dimension) {
        for (var i = 0; i < dimension; i++) {
            for (var j = 0; j < dimension; j++) {
                if (this.isMasked(i, j)) {
                    bits.flip(j, i);
                }
            }
        }
    };
    return DataMask011;
}());
export { DataMask011 };
var DataMask100 = /** @class */ (function () {
    function DataMask100() {
        this.isMasked = function (i, j) {
            return (((this.URShift(i, 1)) + (j / 3)) & 0x01) == 0;
        };
    }
    DataMask100.prototype.unmaskBitMatrix = function (bits, dimension) {
        for (var i = 0; i < dimension; i++) {
            for (var j = 0; j < dimension; j++) {
                if (this.isMasked(i, j)) {
                    bits.flip(j, i);
                }
            }
        }
    };
    DataMask100.prototype.URShift = function (number, bits) {
        if (number >= 0)
            return number >> bits;
        else
            return (number >> bits) + (2 << ~bits);
    };
    return DataMask100;
}());
export { DataMask100 };
var DataMask101 = /** @class */ (function () {
    function DataMask101() {
        this.isMasked = function (i, j) {
            var temp = i * j;
            return (temp & 0x01) + (temp % 3) == 0;
        };
    }
    DataMask101.prototype.unmaskBitMatrix = function (bits, dimension) {
        for (var i = 0; i < dimension; i++) {
            for (var j = 0; j < dimension; j++) {
                if (this.isMasked(i, j)) {
                    bits.flip(j, i);
                }
            }
        }
    };
    return DataMask101;
}());
export { DataMask101 };
var DataMask110 = /** @class */ (function () {
    function DataMask110() {
        this.isMasked = function (i, j) {
            var temp = i * j;
            return (((temp & 0x01) + (temp % 3)) & 0x01) == 0;
        };
    }
    DataMask110.prototype.unmaskBitMatrix = function (bits, dimension) {
        for (var i = 0; i < dimension; i++) {
            for (var j = 0; j < dimension; j++) {
                if (this.isMasked(i, j)) {
                    bits.flip(j, i);
                }
            }
        }
    };
    return DataMask110;
}());
export { DataMask110 };
var DataMask111 = /** @class */ (function () {
    function DataMask111() {
        this.isMasked = function (i, j) {
            return ((((i + j) & 0x01) + ((i * j) % 3)) & 0x01) == 0;
        };
    }
    DataMask111.prototype.unmaskBitMatrix = function (bits, dimension) {
        for (var i = 0; i < dimension; i++) {
            for (var j = 0; j < dimension; j++) {
                if (this.isMasked(i, j)) {
                    bits.flip(j, i);
                }
            }
        }
    };
    return DataMask111;
}());
export { DataMask111 };
var DataMask = /** @class */ (function () {
    function DataMask() {
    }
    DataMask.forReference = function (reference) {
        if (reference < 0 || reference > 7) {
            throw "System.ArgumentException";
        }
        return DataMask.DATA_MASKS[reference];
    };
    DataMask.DATA_MASKS = new Array(new DataMask000(), new DataMask001(), new DataMask010(), new DataMask011(), new DataMask100(), new DataMask101(), new DataMask110(), new DataMask111());
    return DataMask;
}());
export { DataMask };
//# sourceMappingURL=datamask.js.map